class Deque<T> {
    var firstNode: Node<T>? = null
    var lastNode: Node<T>? = null

    // Remove value at back
    fun pop(): T{
        val returnData = lastNode!!.data
        lastNode = lastNode?.beforeNode
        return returnData
    }

    // Add value at back
    fun push(elem: T): Unit {
        if (firstNode == null) {
            firstNode = Node<T>(data = elem, beforeNode = null, afterNode = null)
        } else {
            if (lastNode == null){
                this.lastNode = Node<T>(data = elem, beforeNode = firstNode, afterNode = null)
                firstNode?.linkBefore(this.lastNode!!)
            }
            else {
                this.lastNode?.linkBefore(Node<T>(data = elem, beforeNode = this.lastNode, afterNode = null))
            }
        }
    }

    // Remove value at front
    fun shift(): T{
        val returnData = firstNode!!.data
        firstNode = firstNode?.afterNode
        return returnData
    }

    // Add value at front
    fun unshift(elem: T): Unit {
        if (firstNode == null) {
            firstNode = Node<T>(data = elem, beforeNode = null, afterNode = null)
        } else {
            if (lastNode == null){
                this.lastNode = this.firstNode
                firstNode = Node<T>(data = elem, beforeNode = null, afterNode = this.lastNode)
                this.lastNode?.linkAfter(firstNode!!)
            }
            else {
                this.firstNode?.linkAfter(Node<T>(data = elem, beforeNode = null, afterNode = this.firstNode))
            }
        }
    }
}

data class Node<R>(val data: R, var beforeNode: Node<R>?, var afterNode: Node<R>?) {
    fun linkBefore(afterNode: Node<R>): Unit {
        this.afterNode = afterNode
        afterNode.beforeNode = this
    }

    fun linkAfter(beforeNode: Node<R>): Unit {
        this.beforeNode = beforeNode
        beforeNode.afterNode = this
    }
}